﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure;
using System.Data.Services.Client;

namespace Ploeh.Samples.Booking.Azure
{
    public class ReservationContext : TableServiceContext
    {
        public ReservationContext(CloudStorageAccount account)
            : base(account.TableEndpoint.AbsoluteUri, account.Credentials)
        {
        }

        public DataServiceQuery<ReservationTableEntity> Reservations
        {
            get { return this.CreateQuery<ReservationTableEntity>("Reservations"); }
        }

        public void AddReservation(ReservationTableEntity reservation)
        {
            this.AddObject("Reservations", reservation);
        }
    }
}
