﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ploeh.Samples.Booking.DomainModel
{
    public class CompositeReservationRoot : IReservationRepository
    {
        private readonly IEnumerable<IReservationRepository> roots;

        public CompositeReservationRoot(params IReservationRepository[] roots)
        {
            this.roots = roots;
        }

        public IEnumerable<IReservationRepository> Roots
        {
            get { return this.roots; }
        }

        #region IReservationRoot Members

        public void AddReservation(ReservationAcceptedEvent reservation)
        {
            foreach (var root in this.roots)
            {
                root.AddReservation(reservation);
            }
        }

        #endregion
    }
}
