﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ploeh.Samples.Booking.DomainModel
{
    public class ConstraintCheckingReservationConsumer : IMessageConsumer<MakeReservationCommand>
    {
        private readonly ICapacityReader reader;

        public ConstraintCheckingReservationConsumer(ICapacityReader reader)
        {
            this.reader = reader;
        }

        #region IMessageConsumer<MakeNewReservationCommand> Members

        public void Consume(MakeReservationCommand command)
        {
            this.reader.GetCapacity(command.Date).TryDecrement(command.Quantity);
        }

        #endregion
    }
}
