﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit.Extensions;
using Xunit;
using Ploeh.Samples.Booking.DomainModel;
using Ploeh.AutoFixture.Xunit;
using Moq;
using Ploeh.SemanticComparison.Fluent;

namespace Ploeh.Samples.Booking.DomainModel.UnitTest
{
    public class ConstraintCheckingReservationConsumerFacts
    {
        [Theory, AutoDomainData]
        public void SutIsMessageConsumer(ConstraintCheckingReservationConsumer sut)
        {
            Assert.IsAssignableFrom<IMessageConsumer<MakeReservationCommand>>(sut);
        }

        [Theory, AutoDomainData]
        public void ConsumeAddsIdToDateRoot([Frozen]Mock<ICapacityReader> readerStub, ConstraintCheckingReservationConsumer sut, MakeReservationCommand cmd, Mock<ICapacity> capacityMock)
        {
            readerStub.Setup(r => r.GetCapacity(cmd.Date)).Returns(capacityMock.Object);
            sut.Consume(cmd);
            capacityMock.Verify(c => c.TryDecrement(cmd.Quantity));
        }
    }
}
