﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit.Extensions;
using Ploeh.Samples.Booking.DomainModel;
using Xunit;
using Ploeh.AutoFixture.Xunit;
using Moq;

namespace Ploeh.Samples.Booking.DomainModel.UnitTest
{
    public class PublishingReserverationRootFacts
    {
        [Theory, AutoDomainData]
        public void SutIsReservationRoot(PublishingReserverationRoot sut)
        {
            Assert.IsAssignableFrom<IReservationRepository>(sut);
        }

        [Theory, AutoDomainData]
        public void AddReservationPublishesEvent([Frozen]Mock<IChannel> channelMock, PublishingReserverationRoot sut, ReservationAcceptedEvent reservation)
        {
            sut.AddReservation(reservation);
            channelMock.Verify(r => r.Send(reservation));
        }
    }
}
