﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit.Extensions;
using Ploeh.AutoFixture.Xunit;
using Xunit;
using Ploeh.AutoFixture;
using Ploeh.AutoFixture.Kernel;

namespace Ploeh.Samples.Booking.WebModel.UnitTest
{
    public class DayViewModelFacts
    {
        [Theory, AutoWebData]
        public void DayIsCorrect([Frozen]int day, DayViewModel sut)
        {
            Assert.Equal(day, sut.Day);
        }

        [Fact]
        public void SoldOutIsCorrect()
        {
            // Fixture setup
            var fixture = new Fixture().Customize(new BookingWebModelCustomization());
            var sut = fixture.Build<DayViewModel>().OmitAutoProperties().CreateAnonymous();
            // Exercise system
            var result = sut.SoldOut;
            // Verify outcome
            Assert.False(result);
            // Teardown
        }

        [Theory]
        [InlineData(false)]
        [InlineData(true)]
        public void SoldOutIsWellBehavedWritableProperty(bool soldOut)
        {
            // Fixture setup
            var fixture = new Fixture().Customize(new BookingWebModelCustomization());
            var sut = fixture.CreateAnonymous<DayViewModel>();
            // Exercise system
            sut.SoldOut = soldOut;
            var result = sut.SoldOut;
            // Verify outcome
            Assert.Equal(soldOut, result);
            // Teardown
        }
    }
}
